#!/usr/bin/ruby
# encoding: utf-8

class VirusScreen	
	def initialize(extlayers, button, nwscreen)
		@layers = Array.new
		@extlayers = extlayers 
		@nwscreen = nwscreen
		#### Partitions etc.
		#### Table for deletion of single partitions
		@parttable = nil
		# list of drives
		@partdrives = Array.new
		# shown partitions
		@partparts = Array.new
		# headers
		@partheaders = Array.new
		# checkboxes
		@partchecks = Array.new
		# labels
		@partlabels = Array.new
		#### progress bar for virus search
		@progressbar = nil
		#### VTE for signature update
		@sigs_vte = Vte::Terminal.new
		@sigs_update_running = false
		@sigs_vte.signal_connect("child-exited") { @sigs_update_running = false } 
		#### VTE for scancl check
		@check_vte = Vte::Terminal.new
		@check_running = false
		@check_vte.signal_connect("child-exited") { @check_running = false } 
		#### VTE for scancl virus scan
		@scan_vte = Vte::Terminal.new
		@scan_running = false
		@scan_vte.signal_connect("child-exited") { @scan_running = false } 
		@scan_log_button = Gtk::Button.new("Details")
		#### Label with scan results at the end
		@resultlabel = nil
		
		#### Was the scan killed?
		@scan_killed = false
		
		### Radiobuttons for methods 
		@archive_yes_radio = Gtk::RadioButton.new
		@archive_no_radio = Gtk::RadioButton.new(@archive_yes_radio)
		@archive_no_radio.active = true
		@action_delete_radio = Gtk::RadioButton.new
		@action_ignore_radio = Gtk::RadioButton.new(@action_delete_radio)
		@action_ignore_radio.active = true
		@action_show_radio = Gtk::RadioButton.new(@action_delete_radio)
		
		fixed = Gtk::Fixed.new
		throbber = Gtk::EventBox.new.add Gtk::Image.new("throbber.gif")
		throbtext = Gtk::Label.new
		throbtext.width_request = 250
		throbtext.wrap = true
		throbtext.set_markup('<span foreground="white">Die Virensignaturen werden im Hintergrund aktualisiert.</span>')
		text5 = Gtk::Label.new
		text5.width_request = 250
		text5.wrap = true
		text5.set_markup("<span color='white'>Klicken Sie hier, um mit Ihren Einstellungen fortzufahren.</span>")
		forw  = Gtk::EventBox.new.add Gtk::Image.new("forward.png")
		archtext = TileHelpers.create_label("Sollen Archive nach Schadsoftware durchsucht werden? Dies verlangsamt die Suche und birgt das Risiko von Suchabbrüchen, steigert jedoch die Erkennungsrate.", 510)
		actiontext =  TileHelpers.create_label("Wie soll nach einem Fund von Schadsoftware weiter vorgegangen werden?", 510)
		
		yestext = TileHelpers.create_label("<b>Ja</b>, Archive durchsuchen", 380)
		notext = TileHelpers.create_label("<b>Nein</b>, Archive ignorieren", 380)
		actdeltext = TileHelpers.create_label("Reparieren (löschen wenn nicht möglich)", 380)
		actigntext = TileHelpers.create_label("Reparieren  (umbenennen wenn nicht möglich)", 380)
		actshowtext = TileHelpers.create_label("Funde nur anzeigen", 380)
	
		button1 = Gtk::EventBox.new.add Gtk::Image.new("neutralturq.png")
		button2 = Gtk::EventBox.new.add Gtk::Image.new("neutralorange.png")
		fixed.put(button1, 0, 0)
		# fixed.put(button2, 0, 130)
		fixed.put(archtext, 130, 0)
		fixed.put(actiontext, 130, 130)
		fixed.put(@archive_yes_radio, 140, 60)
		fixed.put(@archive_no_radio, 140, 90)
		fixed.put(yestext, 165, 63)
		fixed.put(notext, 165, 93)
		fixed.put(@action_delete_radio, 140, 170)
		fixed.put(@action_ignore_radio, 140, 195)
		fixed.put(@action_show_radio, 140, 220)
		fixed.put(actdeltext, 165, 173)
		fixed.put(actigntext, 165, 198)
		fixed.put(actshowtext, 165, 223)
	
		fixed.put(forw, 853, 282)
		fixed.put(text5, 605, 288)
		TileHelpers.place_back(fixed, extlayers)
		# fixed.put(throbber, 0, 332)
		# fixed.put(throbtext, 52, 338)
		
		extlayers["virusstart"] = fixed
		@layers[0] = fixed
		button.signal_connect('button-release-event') { |x, y|
			if y.button == 1 
				extlayers.each { |k,v|v.hide_all }
				if nwscreen.test_connection == false
					nwscreen.nextscreen = "virusstart"
					nwscreen.fill_wlan_combo 
					# Check for networks first...
					extlayers["networks"].show_all
				else
					extlayers["virusstart"].show_all
				end
			end
		}
		forw.signal_connect('button-release-event') { |x, y|
			if y.button == 1 
				@partdrives, @partparts, @partheaders, @partchecks, @partlabels = fill_part_tab(@parttable, @partheaders, @partchecks, @partlabels)
				extlayers.each { |k,v|v.hide_all }
				extlayers["virusdrives"].show_all
			end
		}
		extlayers["virusdrives"] = create_drive_screen(extlayers)
		@layers[1] = extlayers["virusdrives"]
		extlayers["virusprogress"] = create_progress_screen(extlayers)
		@layers[2] = extlayers["virusprogress"]
		extlayers["virusresult"] = create_result_screen(extlayers)
		@layers[3] = extlayers["virusresult"]
	end
	attr_reader :layers
	
	def create_drive_screen(extlayers)
		### Layer for deletion of single partitions
		fixed = Gtk::Fixed.new
		tile = Gtk::Image.new("neutralorange.png")
		TileHelpers.place_back(fixed, extlayers)
		delscroll = Gtk::ScrolledWindow.new
		delscroll.height_request = 195
		delscroll.width_request = 760
		delscroll.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC ) 
		drivetext = TileHelpers.create_label("<b>Auswahl der Laufwerke:</b> Wählen Sie hier die Laufwerke aus, auf denen Sie nach Schadsoftware suchen wollen.", 510)
		# Table for drives
		@parttable = Gtk::Table.new(2, 11, false)
		align = Gtk::Alignment.new(0, 0, 0.1, 0.1)
		align.add @parttable
		delscroll.add_with_viewport align
		anc = @parttable.get_ancestor(Gtk::Viewport)
		anc.modify_bg(Gtk::STATE_NORMAL, Gdk::Color.parse('#005163') )
		# puts anc.to_s
		# Forward button:
		text5 = TileHelpers.create_label("Klicken Sie hier, um die Suche nach Schadsoftware zu starten.", 250)
		forw  = Gtk::EventBox.new.add Gtk::Image.new("forward.png")
		forw.signal_connect('button-release-event') { |x, y|
			if y.button == 1 
				extlayers.each { |k,v|v.hide_all }
				extlayers["virusprogress"].show_all
				run_virus_check
			end
		}
		
		fixed.put(tile, 0, 0)
		fixed.put(delscroll, 130, 65)
		fixed.put(drivetext, 130, 0)
		fixed.put(forw, 853, 282)
		fixed.put(text5, 605, 288)
		return fixed
	end
	
	def create_progress_screen(extlayers)
		fixed = Gtk::Fixed.new
		tile = Gtk::Image.new("neutralorange.png")
		drivetext = TileHelpers.create_label("<b>Suche nach Schadsoftware</b>\n\nDie Suche nach Schadsoftware wird jetzt durchgeführt. Der Fortschrittsbalken zeigt Ihnen aktuelle Aktionen und voraussichtlich verbleibende Zeit.", 510)
		@progressbar = Gtk::ProgressBar.new
		@progressbar.width_request = 415
		@progressbar.height_request = 32
		@scan_log_button.width_request = 90
		@scan_log_button.height_request = 32
		cancelbutton = TileHelpers.place_back(fixed, extlayers, false)
		fixed.put(tile, 0, 0)
		fixed.put(@progressbar, 130, 88)
		fixed.put(@scan_log_button, 550, 88)
		@scan_log_button.signal_connect('clicked') {
			system("/usr/bin/Terminal --hide-menubar -e 'tail -f /var/log/virusscan.log' &") 
		}
		fixed.put(drivetext, 130, 0)
		return fixed
	end
	
	def create_result_screen(extlayers)
		fixed = Gtk::Fixed.new
		tile = Gtk::Image.new("neutralorange.png")
		@resultlabel = TileHelpers.create_label("<b>Suche nach Schadsoftware abgeschlossen</b>\n\nDie Suche nach Schadsoftware ist abgeschlossen.", 510)
		log_button = Gtk::Button.new("Protokoll anzeigen")
		log_button.width_request = 150
		log_button.height_request = 32
		fixed.put(tile, 0, 0)
		fixed.put(@resultlabel, 130, 0)		
		fixed.put(log_button, 490, 240)
		log_button.signal_connect('clicked') {
			system("gedit /var/log/virusscan.log &") 
		}
		TileHelpers.place_back(fixed, extlayers)
		return fixed
	end
	
	def fill_part_tab(table, oldheaders, oldchecks, oldlabels)
		table.row_spacings = 4
		parts = Array.new
		headers = Array.new
		drives = Array.new
		checks = Array.new
		labels = Array.new
		Dir.entries("/sys/block").each { |l|
			drives.push(MfsDiskDrive.new(l, false)) if l =~ /[a-z]$/ 
		}
		oldheaders.each { |h| table.remove h }
		oldlabels.each{ |l| table.remove l } 
		oldchecks.each{ |c| table.remove c } 
		
		table.resize(drives.size * 100, 2)
		rowcount = 0
		drives.each { |d|
			label = "<b>#{d.vendor} #{d.model} - #{d.human_size} - #{d.device}"
			if d.usb == true
				label = label + " (USB)</b>\n"
			else
				label = label + " (SATA/eSATA/IDE)</b>\n"
			end
			l = TileHelpers.create_label(label, 670)
			l.height_request = 17
			headers.push l
			table.attach(l, 0, 2, rowcount, rowcount+1)
			rowcount += 1
			d.partitions.each { |p|
				unless p.fs.to_s.strip == ""
					pt = "#{p.device} - #{p.human_size} - #{p.fs}"
					iswin, winvers = p.is_windows
					pt = pt + " - " + winvers if iswin 
					pl = TileHelpers.create_label(pt, 650)
					cb = Gtk::CheckButton.new
					cb.active = true if p.fs =~ /ntfs/ || p.fs =~ /vfat/  
					labels.push pl
					checks.push cb
					parts.push p
					table.attach(pl, 1, 2, rowcount, rowcount+1)
					table.attach(cb, 0, 1, rowcount, rowcount+1)
					rowcount += 1
				end
			}
			
		}
		table.resize(rowcount, 2)
		return drives, parts, headers, checks, labels
	end
	
	def run_virus_check
		@scan_killed == false
		@scan_log_button.sensitive = false
		# count files
		# filecount = 0
		# 0.upto(@partchecks.size - 1) { |n|
		#	filecount += @partparts[n].filecount(@progressbar) if @partchecks[n].active? 
		# }
		# update signatures - if not already done in background
		update_signatures
		while @sigs_update_running == true
			sleep 0.2
			@progressbar.text = "Aktualisiere Virensignaturen" 
			@progressbar.pulse 
			while (Gtk.events_pending?)
				Gtk.main_iteration
			end
		end
		# check usability of scancl
		check_scancl
		while @check_running == true
			sleep 0.2
			@progressbar.text = "Prüfe Funktionalität des Virenscanners" 
			@progressbar.pulse 
			while (Gtk.events_pending?)
				Gtk.main_iteration
			end
		end
		check_success = File.read("/var/log/scancl-check.ret").strip.to_i
		if check_success > 0 && @scan_killed == false
			TileHelpers.error_dialog("Der Virenscanner ist defekt oder die Lizenzdatei ist zu alt! Probieren Sie eine Aktualisierung der Signaturen und versuchen Sie danach erneut, einen Virenscan durchzuführen. Details können Sie der Datei \"/var/log/scancl-check.log\" entnehmen. Klicken Sie auf \"OK\", um zum Startbildschirm zurückzukehren.", "Virenscanner defekt")
			@extlayers.each { |k,v|v.hide_all }
			@extlayers["start"].show_all 
		end
		# Now run the real check for malicious software
		scanparams = Array.new
		scanparams.push("/AntiVir/scancl")
		scanparams.push("--recursion")
		scanparams.push("-z") if @archive_yes_radio.active? 
		scanparams.push("--defaultaction=clean,delete,delete-archive") if @action_delete_radio.active?
		scanparams.push("--defaultaction=clean,rename") if @action_ignore_radio.active?
		scanparams.push("--defaultaction=ignore") if @action_show_radio.active?
		scanparams.push("--heurlevel=2")
		scanparams.push("--nolinks")
		scanparams.push("--log=/var/log/virusscan.log")
		scanparams.push("--logformat=singleline")
		scanparams.push("/media")
		puts scanparams.join(" ")
		if @scan_killed == true
			@extlayers.each { |k,v|v.hide_all }
			@extlayers["start"].show_all 
			return false
		end
		0.upto(@partchecks.size - 1) { |n|
			if @partchecks[n].active? 
				system("mkdir -p /media/" + @partparts[n].device)
				@partparts[n].mount("rw", "/media/" + @partparts[n].device)
			end
		}
		scan_scancl(scanparams)
		@scan_log_button.sensitive = true
		while @scan_running == true
			sleep 0.2
			@progressbar.text = "Führe Virenscan durch" 
			@progressbar.pulse 
			while (Gtk.events_pending?)
				Gtk.main_iteration
			end
		end
		@scan_log_button.sensitive = false
		0.upto(@partchecks.size - 1) { |n|
			if @partchecks[n].active? 
				@partparts[n].umount
			end
		}
		if @scan_killed == true
			@extlayers.each { |k,v|v.hide_all }
			@extlayers["start"].show_all 
			return false
		end
		# Now analyze the log file and jump to the result screen
		analyze_log
		@extlayers.each { |k,v|v.hide_all }
		@extlayers["virusresult"].show_all 
		 
	end
	
	def update_signatures
		return false if @sigs_update_running == true
		return false if @nwscreen.test_connection == false
		@sigs_update_running = true
		@sigs_vte.fork_command("/bin/bash", [ "/bin/bash", "avupdate_wrapper.sh" ] )
	end
	
	def check_scancl
		return false if @check_running == true
		@check_running = true
		@check_vte.fork_command("/bin/bash", [ "/bin/bash", "check_wrapper.sh" ]  )
	end
	
	def scan_scancl(scanparams)
		return false if @scan_running == true
		@scan_running = true
		@scan_vte.fork_command("/AntiVir/scancl", scanparams )
	end
	
	def analyze_log 
		inside = false
		infected = 0
		total = 0
		text = ""
		File.open("/var/log/virusscan.log").each { |line|
			begin 
				inside = true if line.strip =~ /^Statistics/ 
			rescue
			end
			if inside == true
				ltoks = line.strip.split
				if line.strip =~ /^Infected/
					infected = ltoks[-1].to_i 
				elsif line.strip =~ /^Files/
					total = ltoks[-1].to_i 
				end
			end
		}
		if inside == false 
			text = "<b>Suche nach Schädlingen abgebrochen</b>\n\nDie unvollständige Logdatei deutet auf einen Abbruch des Virenscans hin. Bitte führen Sie die Suche mit anderen Einstellungen oder im Expertenmodus erneut durch." 
		elsif infected < 1
			text = "<b>Keine Schadsoftware gefunden</b>\n\nDer Virenscan ist abgeschlossen. Insgesamt wurden #{total.to_s} Dateien untersucht. Keine der untersuchten Dateien wies Schädlingsbefall auf." 
		elsif @action_show_radio.active? == true
			text = "<b>Schadsoftware gefunden</b>\n\nDer Virenscan ist abgeschlossen. Insgesamt wurden #{total.to_s} Dateien untersucht. #{infected.to_s} Dateien weisen Schädlingsbefall auf. <b>Achtung!</b> Ihre Einstellungen für den Virenscan sahen ausdrücklich vor, infizierte Dateien nicht zu reinigen. Bitte nehmen Sie eine solche Reinigung vor, bevor Sie den Computer wieder in Betrieb nehmen." 
		else
			text = "<b>Schadsoftware gefunden</b>\n\nDer Virenscan ist abgeschlossen. Insgesamt wurden #{total.to_s} Dateien untersucht. #{infected.to_s} Dateien wiesen Schädlingsbefall auf und wurden gemäß der von Ihnen vorgenommenen Einstellungen unschädlich gemacht." 
		end
		#### BKA-Trojaner-Text
		
		
		
		@resultlabel.set_markup("<span color='white'>#{text}</span>") 
		
		
	end
	
end